! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!
! Module: eimsim_utils
!
! Authors:  Ian Stewart - SSC/LUX
!          
! Description: Contains XMM-specific global variables.
! 
! Comments: TODO:
! 
! $Id: eimsim_utils.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module eimsim_utils

  use dal
  use caltypes

  use dal_aux

  implicit none 

  private 

  type, public :: localSrcDataType !!! only used in makeSourceListClumped.
    real(single) ::&
      xPixels,&
      yPixels,&
      exposure,&
      rate,&
      peakRate,&
      extentWorld,&
      extentPixels
    real(double) ::&
      raDeg,&
      decDeg,&
      EeV,&
      thetaArcsec,&
      phi
    integer(int32) ::&
      flag
  end type localSrcDataType

!  type :: rangesPtrType
!    type(RangeT), pointer :: ranges(:)
!  end type rangesPtrType

  type :: intervalsPtrType
    type(IntervalT), pointer :: intervals(:)
  end type intervalsPtrType

  integer(int32), public ::& ! flag bits
    NOT_IN_M1_FOV_BIT =  0,&
    NOT_IN_M2_FOV_BIT =  1,&
    NOT_IN_PN_FOV_BIT =  2,&
    NOT_IN_M1_EXP_BIT =  3,&
    NOT_IN_M2_EXP_BIT =  4,&
    NOT_IN_PN_EXP_BIT =  5,&
!    DETECTED_M1   =  6,&
!    DETECTED_M2   =  7,&
!    DETECTED_PN   =  8,&
DETECTED_BIT   =  6,&
!    COARSE_PSF_BIT(5)  =  (/9, 10, 11, 12, 13/)
COARSE_PSF_BIT    =  7
!***** change the relevant routine too

  real(single), parameter :: detSrcXoffset = -0.5, detSrcYoffset = -0.5
  ! Both in image pixels.

  real(single), public, parameter :: vignettedSkirtFraction = 0.3

!  integer, public, parameter :: numInsts = 3, numBands = 5

!  public getConversionFactors

contains 

!  !---------------------------------------------------------------------
!  subroutine getConversionFactors(tab, ecfs, fluxDensitiesToFluxes&
!  , fluxDensityToFlux)
!  !---------------------------------------------------------------------
!
!    implicit none
!
!    type(TableT), intent(in)  :: tab
!    real(single), intent(out) :: ecfs(numInsts, numBands),&
!                                 fluxDensitiesToFluxes(numBands),&
!                                 fluxDensityToFlux
!
!    !-------------------------------------------------------------------
!    ! Start
!
!    call readColDataToFixed(tab, 'ECF_PN', ecfs(1,:)) ! in ssclib/dal_aux.
!    call readColDataToFixed(tab, 'ECF_M1', ecfs(2,:)) ! in ssclib/dal_aux.
!    call readColDataToFixed(tab, 'ECF_M2', ecfs(3,:)) ! in ssclib/dal_aux.
!    call readColDataToFixed(tab, 'FLUX', fluxDensitiesToFluxes) ! in ssclib/dal_aux.
!    fluxDensityToFlux = real32Attribute(tab, 'FLUX')
!
!  end subroutine getConversionFactors

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module eimsim_utils
